# See the loader file for license and author info

require 'sketchup.rb'
module CLF_Extensions_NS

  module CLF_Extended_Views

    def self.main(flag)
      model = Sketchup.active_model
      ents = model.active_entities

      pt1 = 0,0,0
      pt2 = 100,0,0
      pt3 = 100,0,100
      pt4 = 0,0,100
      pt5 = 0,100,0
      
      group = ents.add_group( )
      gents = group.entities
      face = gents.add_face( pt1, pt2, pt3, pt4 )
      gents.add_cpoint pt5
      group2 = ents.add_group( group )
      group_delete = group2.entities[0]
      gents = group2.entities
      
      bb = group2.bounds
      bbp0 = bb.corner 0
      bbp1 = bb.corner 1
      bbp2 = bb.corner 2
      bbp3 = bb.corner 3
      bbp4 = bb.corner 4
      bbp5 = bb.corner 5
      bbp6 = bb.corner 6
      bbp7 = bb.corner 7
      
      cp0 = gents.add_cpoint bbp0
      cp1 = gents.add_cpoint bbp1
      cp2 = gents.add_cpoint bbp2
      cp3 = gents.add_cpoint bbp3
      cp4 = gents.add_cpoint bbp4
      cp5 = gents.add_cpoint bbp5
      cp6 = gents.add_cpoint bbp6
      cp7 = gents.add_cpoint bbp7
      to_delete = [cp0, cp1, cp2, cp3, cp4, cp5, cp6, cp7]
      gents.erase_entities group_delete
      cpoints = group2.explode
      
      case flag
      when 0 #Iso
        p1 = Geom::Point3d.linear_combination 0.5, cp0.position.clone, 0.5, cp4.position.clone
        p2 = cp3.position.clone
        p3 = cp4.position.clone
      when 1 #Top
        p1 = cp4.position.clone
        p2 = cp0.position.clone
        p3 = cp2.position.clone
      when 2 #Front
        p1 = cp0.position.clone
        p2 = cp2.position.clone
        p3 = cp4.position.clone
      when 3 #Right
        p1 = cp1.position.clone
        p2 = cp0.position.clone
        p3 = cp5.position.clone
      when 4 #Back
        p1 = cp2.position.clone
        p2 = cp0.position.clone
        p3 = cp6.position.clone
      when 5 #Left
        p1 = cp0.position.clone
        p2 = cp1.position.clone
        p3 = cp4.position.clone
      when 6 #Bottom
        p1 = cp0.position.clone
        p2 = cp4.position.clone
        p3 = cp2.position.clone
      end
      
      ents.erase_entities to_delete
      
      # Get the current camera and its current perspective status.
      view = Sketchup.active_model.active_view
      current_camera = view.camera
      current_perspective = current_camera.perspective?
      # Set up the new camera matching the previous camera perspective
      new_camera = Sketchup::Camera.new
      new_camera.perspective = current_perspective
      # Set the camera position (eye), target, and the "up" vector for the camera.
      eye = p1
      target = p2
      up =  p1.vector_to p3
      # Create the new camera with the desired parameters and zoom extents when finished.
      new_camera = new_camera.set eye, target, up
      view.camera = new_camera
      view.zoom_extents
    end
  end
end